Scala Compiler2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package typechecker
  Definition Classes
    nsc
-  trait Macros extends MacroRuntimes with Traces with Helpers

  Code to deal with macros, namely with: * Compilation of macro definitions * Expansion of macro applications

  Code to deal with macros, namely with: * Compilation of macro definitions * Expansion of macro applications

  Say we have in a class C:

  def foo[T](xs: List[T]): T = macro fooBar

  Then fooBar needs to point to a static method of the following form:

  def fooBar[T: c.WeakTypeTag] // type tag annotation is optional (c: scala.reflect.macros.blackbox.Context) (xs: c.Expr[List[T]]) : c.Expr[T] = { ... }

  Then, if foo is called in qual.foo[Int](elems), where qual: D, the macro application is expanded to a reflective invocation of fooBar with parameters:

  (simpleMacroContext{ type PrefixType = D; val prefix = qual }) (Expr(elems)) (TypeTag(Int))

  Definition Classes
    typechecker
- DefMacroExpander
- Delayed
- Failure
- Fallback
- JavaReflectionResolvers
- MacroArgs
- MacroExpander
- MacroImplBinding
- MacroRuntimeResolver
- MacroStatus
- Skipped
- Success

c

scala.tools.nsc.typechecker.Macros

# MacroStatus 

###

#### sealed abstract class MacroStatus extends AnyRef

Source
  Macros.scala

Linear Supertypes
AnyRef, Any
Known Subclasses
Delayed, Failure, Fallback, Skipped, Success
Type Hierarchy
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. MacroStatus
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from Analyzer.MacroStatus to any2stringadd[Analyzer.MacroStatus] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (Analyzer.MacroStatus, B)
   Implicit
     This member is added by an implicit conversion from Analyzer.MacroStatus to ArrowAssoc[Analyzer.MacroStatus] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
7.  def clone(): AnyRef
   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
8.  def ensuring(cond: (Analyzer.MacroStatus) ⇒ Boolean, msg: ⇒ Any): Analyzer.MacroStatus
   Implicit
     This member is added by an implicit conversion from Analyzer.MacroStatus to Ensuring[Analyzer.MacroStatus] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring
9.  def ensuring(cond: (Analyzer.MacroStatus) ⇒ Boolean): Analyzer.MacroStatus
   Implicit
     This member is added by an implicit conversion from Analyzer.MacroStatus to Ensuring[Analyzer.MacroStatus] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring
10.  def ensuring(cond: Boolean, msg: ⇒ Any): Analyzer.MacroStatus
    Implicit
      This member is added by an implicit conversion from Analyzer.MacroStatus to Ensuring[Analyzer.MacroStatus] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
11.  def ensuring(cond: Boolean): Analyzer.MacroStatus
    Implicit
      This member is added by an implicit conversion from Analyzer.MacroStatus to Ensuring[Analyzer.MacroStatus] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
12.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
13.  def equals(arg0: Any): Boolean
    Definition Classes
      AnyRef → Any
14.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
15.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from Analyzer.MacroStatus to StringFormat[Analyzer.MacroStatus] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
16.  final def getClass(): Class[_]
    Definition Classes
      AnyRef → Any
17.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
18.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
19.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
20.  final def notify(): Unit
    Definition Classes
      AnyRef
21.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
22.  val result: Global.Tree
23.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
24.  def toString(): String
    Definition Classes
      AnyRef → Any
25.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
26.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
27.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
28.  def →[B](y: B): (Analyzer.MacroStatus, B)
    Implicit
      This member is added by an implicit conversion from Analyzer.MacroStatus to ArrowAssoc[Analyzer.MacroStatus] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Analyzer.MacroStatus to any2stringadd[Analyzer.MacroStatus]

### Inherited by implicit conversion StringFormat from Analyzer.MacroStatus to StringFormat[Analyzer.MacroStatus]

### Inherited by implicit conversion Ensuring from Analyzer.MacroStatus to Ensuring[Analyzer.MacroStatus]

### Inherited by implicit conversion ArrowAssoc from Analyzer.MacroStatus to ArrowAssoc[Analyzer.MacroStatus]

### Ungrouped